diff --git a/src/decode.h b/src/decode.h
index c664e9e..3a9dfd7 100644
--- a/src/decode.h
+++ b/src/decode.h
@@ -379,6 +379,107 @@ struct enc_header {
 #define DHCP_CLIENT_PORT    68
 #define DHCP_SERVER_PORT    67
 
+
+/*
+ * SCTP Definitions
+ */
+
+/* SCTP Chunk types. */
+#define SCTP_DATA_C                 0x00    /* DATA chunk (RFC4960) */
+#define SCTP_INIT_C                 0x01    /* INIT chunk (RFC4960) */
+#define SCTP_INIT_ACK_C             0x02    /* INIT-ACK chunk (RFC4960) */
+#define SCTP_SACK_C                 0x03    /* SACK chunk (RFC4960) */
+#define SCTP_HEARTBEAT_C            0x04    /* HEARTBEAT chunk (RFC4960) */
+#define SCTP_HEARTBEAT_ACK_C        0x05    /* HEARTBEAT-ACK chunk (RFC4960) */
+#define SCTP_ABORT_C                0x06    /* ABORT chunk (RFC4960) */
+#define SCTP_SHUTDOWN_C             0x07    /* SHUTDOWN chunk (RFC4960) */
+#define SCTP_SHUTDOWN_ACK_C         0x08    /* SHUTDOWN-ACK chunk (RFC4960) */
+#define SCTP_ERROR_C                0x09    /* ERROR chunk (RFC4960) */
+#define SCTP_COOKIE_ECHO_C          0x0a    /* COOKIE-ECHO chunk (RFC4960) */
+#define SCTP_COOKIE_ACK_C           0x0b    /* COOKIE-ACK chunk (RFC4960) */
+#define SCTP_ECNE_C                 0x0c    /* ECNE (Explicit Congestion Notification) chunk (RFC4960) */
+#define SCTP_CWR_C                  0x0d    /* CWR (Congestion Window Reduced) chunk (RFC4960) */
+#define SCTP_SHUTDOWN_COMPLETE_C    0x0e    /* SHUTDOWN-COMPLETE chunk (RFC4960) */
+#define SCTP_AUTH_C                 0x0f    /* AUTH chunk (RFC4895) */
+#define SCTP_ASCONF_ACK_C           0x80    /* ASCONF-ACK chunk (RFC5061) */
+#define SCTP_PKTDROP_C              0x81    /* PKTDROP chunk (draft-stewart-sctp-pktdrprep-12) */
+#define SCTP_RECONFIG_C             0x82    /* RE-CONFIG chunk (draft-ietf-tsvwg-sctp-strrst-12) */
+#define SCTP_PAD_C                  0x84    /* PAD chunk (RFC4820) */
+#define SCTP_FORWARD_TSN_C          0xc0    /* FORWARD-TSN chunk (RFC3758) */
+#define SCTP_ASCONF_C               0xc1    /* ASCONF chunk (RFC5061) */
+
+/* SCTP header lengths (minimum, anyways). */
+#define SCTP_COMMON_HEADER_LEN      12      /* SCTP common header is 12 bytes */
+#define SCTP_CAUSE_HEADER_LEN        4      /* SCTP cause header length is 4 bytes */
+#define SCTP_PARAM_HEADER_LEN        4      /* SCTP parameter header length is 4 bytes */
+#define SCTP_MAX_PADDING_LEN         3      /* Maximum amount of padding allowed to align data. */
+#define SCTP_DATA_C_LEN             17      /* Minimum size of a DATA (0x00) chunk */
+#define SCTP_INIT_C_LEN             20      /* Minimum size of an INIT (0x01) chunk */
+#define SCTP_INIT_ACK_C_LEN         20      /* Same as INIT, except type is 0x02) */
+#define SCTP_SACK_C_LEN             16      /* Minimum size of a SACK (0x03) chunk */
+#define SCTP_HEARTBEAT_C_LEN         8      /* Minimum size of a HEARTBEAT (0x04) chunk */
+#define SCTP_HEARTBEAT_ACK_C_LEN     8      /* Minimum size of a HEARTBEAT ACK (0x05) chunk */
+#define SCTP_ABORT_C_LEN             4      /* Minimum size of an ABORT (0x06) chunk */
+#define SCTP_SHUTDOWN_C_LEN          8      /* Minimum size of a SHUTDOWN (0x07) chunk */
+#define SCTP_SHUTDOWN_ACK_C_LEN      4      /* Minimum size of a SHUTDOWN ACK (0x08) chunk */
+#define SCTP_ERROR_C_LEN             8      /* Minimum size of an ERROR (0x09) chunk */
+#define SCTP_COOKIE_ECHO_C_LEN       4      /* Minimum size of a COOKIE ECHO (0x0a) chunk */
+#define SCTP_COOKIE_ACK_C_LEN        4      /* Minimum size of a COOKIE ACK (0x0b) chunk */
+#define SCTP_ECNE_C_LEN              8      /* Minimum size of an ECNE (0x0c) chunk */
+#define SCTP_CWR_C_LEN               8      /* Minimum size of a CWR (0x0d) chunk */
+#define SCTP_SHUTDOWN_COMPLETE_C_LEN 4      /* Minimum size of a SHUTDOWN COMPLETE (0x0e) chunk */
+#define SCTP_AUTH_C_LEN              4      /* Minimum size of an AUTH (0x0f) chunk */
+#define SCTP_ASCONF_ACK_C_LEN        8      /* Minimum size of an ASCONF ACK (0x80) chunk */
+#define SCTP_PKTDROP_C_LEN          16      /* Minimum size of a PKTDROP (0x81) chunk */
+#define SCTP_RECONFIG_C_LEN          4      /* Minimim size of a RE-CONFIG (0x82) chunk */
+#define SCTP_PAD_C_LEN               4      /* Minimum size of a PAD (0x84) chunk */
+#define SCTP_FORWARD_TSN_C_LEN      12      /* Minimum size of a FORWARD TSN (0xc0) chunk */
+#define SCTP_ASCONF_C_LEN           12      /* Minimum size of an ASCONF (0xc1) chunk */
+
+/* SCTP Parameter Types. */
+#define SCTP_HEARTBEAT_INFO_P       0x0001  /* Heartbeat Info */
+    /* 0x0002 - 0x0004 Unassigned */
+#define SCTP_IPV4_ADDR_P            0x0005  /* IPv4 Address */
+#define SCTP_IPV6_ADDR_P            0x0006  /* IPv6 Address */
+#define SCTP_STATE_COOKIE_P         0x0007  /* State Cookie */
+#define SCTP_UNKNOWN_P              0x0008  /* Unrecognized Parameters */
+#define SCTP_COOKIE_PRESERVE_P      0x0009  /* Cookie Preservative */
+#define SCTP_HOSTNAME_ADDR_P        0x000b  /* Host Name Address */
+#define SCTP_SUPP_ADDRTYPES_P       0x000c  /* Supported Address Types */
+    /* draft-ietf-tsvwg-sctp-strrst-12 */
+#define SCTP_OUT_SSN_RST_REQ_P      0x000d  /* Outgoing SSN Reset Request */
+#define SCTP_IN_SSN_RST_REQ_P       0x000e  /* Incoming SSN Reset Request */
+#define SCTP_SSNTSN_RST_REQ_P       0x000f  /* SSN/TSN Reset Request */
+#define SCTP_RECONFIG_RESP_P        0x0010  /* Re-configuration Response */
+#define SCTP_ADD_OUT_STRM_REQ_P     0x0011  /* Add Outgoing Streams Request */
+#define SCTP_ADD_IN_STRM_REQ_P      0x0012  /* Add Incoming Streams Request */
+    /* 0x0013 = 0x7fff Unassigned */
+#define SCTP_ECN_CAPABLE_P          0x8000  /* ECN Capable (Reserved) */
+#define SCTP_NONCE_SUPPORTED_P      0x8001  /* Nonce-Supported */
+#define SCTP_RANDOM_P               0x8002  /* Random */
+#define SCTP_CHUNK_LIST_P           0x8003  /* Chunk List */
+#define SCTP_REQ_HMAC_ALGO_P        0x8004  /* Requested HMAC Algorithm Parameter */
+#define SCTP_PADDING_P              0x8005  /* Padding */
+#define SCTP_SUPP_EXTEN_P           0x8008  /* Supported Extensions */
+    /* 0x8009 - 0xbfff Unassigned */
+#define SCTP_SUPP_FWD_TSN_P         0xc000  /* Forward TSN Supported */
+#define SCTP_ADD_IP_P               0xc001  /* Add IP */
+#define SCTP_DEL_IP_P               0xc002  /* Delete IP */
+#define SCTP_SUPP_ERR_CAUSE_P       0xc003  /* Error Cause Indication */
+#define SCTP_PRIMARY_ADDR_P         0xc004  /* Set Primary Address */
+#define SCTP_SUCCESS_P              0xc005  /* Success Indication */
+#define SCTP_ADAPT_LAYER_P          0xc006  /* Adaptation Layer Indication */
+
+/* SCTP HMAC Algorithm bits. */
+#define SCTP_SHA1_HMAC              0x0001  /* HMAC SHA-1 */
+#define SCTP_SHA256_HMAC            0x0003  /* HMAC SHA-256 */
+
+/* Misc SCTP Bits.  Borrowed from Wireshark. */
+#define SCTP_ADD_PADDING(x) ((((x) + 3) >> 2) << 2)
+
+/* End SCTP definitions */
+
+
 #ifndef NO_NON_ETHER_DECODER
 /* Start Token Ring */
 #define TR_ALEN             6        /* octets in an Ethernet header */
@@ -661,8 +762,9 @@ typedef enum {
 #define PKT_ERR_CKSUM_UDP    0x04
 #define PKT_ERR_CKSUM_ICMP   0x08
 #define PKT_ERR_CKSUM_IGMP   0x10
-#define PKT_ERR_CKSUM_ANY    0x1F
-#define PKT_ERR_BAD_TTL      0x20
+#define PKT_ERR_CKSUM_SCTP   0x20
+#define PKT_ERR_CKSUM_ANY    0x3F
+#define PKT_ERR_BAD_TTL      0x40
 
 /*  D A T A  S T R U C T U R E S  *********************************************/
 typedef int (*LogFunction)(void *ssnptr, uint8_t **buf, uint32_t *len, uint32_t *type);
@@ -1541,6 +1643,227 @@ typedef struct _EtherARP
 }         EtherARP;
 
 
+/*
+ * SCTP data structures
+ */
+#ifdef _MSC_VER
+  /* Visual C++ pragma to disable warning
+   * messages about nonstandard bit field type
+   */
+  #pragma warning( disable : 4214 )
+#endif
+
+#pragma pack(push)  /* push current alignment to stack */
+#pragma pack(1)     /* set alignment to 1 byte boundary */
+
+typedef struct _SCTPHdr
+{
+    uint16_t sh_sport;        /* Source port */
+    uint16_t sh_dport;        /* Destination port */
+    uint32_t sh_vtag;         /* Verification tag */
+    uint32_t sh_csum;         /* Checksum (CRC32c/Adler32) */
+    uint8_t chunks[0];        /* Start of SCTP Chunks */
+} SCTPHdr;
+
+/* Sctp Cause Header (for the ABORT/ERROR chunks). */
+typedef struct _SctpCause
+{
+    uint16_t code;
+    uint16_t length;
+    uint8_t info[0];
+} SctpCause;
+
+/* Sctp Param Header. */
+typedef struct _SctpParam
+{
+    uint16_t type;
+    uint16_t length;
+    uint8_t value[0];
+} SctpParam;
+
+/* Sctp Chunk Type Definitions. */
+typedef struct _SctpDataChunk
+{
+    uint32_t tsn;
+    uint16_t stream_id;
+    uint16_t stream_seq;
+    uint32_t payload_id;
+    uint8_t data[0];
+} SctpDataChunk;
+
+typedef struct _SctpInitChunk
+{
+    uint32_t initiate_tag;
+    uint32_t a_rwnd;
+    uint16_t num_out_streams;
+    uint16_t num_in_streams;
+    uint32_t tsn;
+    uint8_t params[0];
+} SctpInitChunk;
+
+typedef struct _SctpInitAckChunk
+{
+    uint32_t initiate_tag;
+    uint32_t a_rwnd;
+    uint16_t num_out_streams;
+    uint16_t num_in_streams;
+    uint32_t tsn;
+    uint8_t params[0];
+} SctpInitAckChunk;
+
+typedef struct _SctpSackChunk
+{
+    uint32_t cuml_tsn_ack;
+    uint32_t a_rwnd;
+    uint16_t num_gap_acks;
+    uint16_t num_dupe_tsns;
+    uint8_t data[0];
+} SctpSackChunk;
+
+typedef struct _SctpHeartbeatChunk
+{
+    uint8_t info[0];
+} SctpHeartbeatChunk;
+
+typedef struct _SctpHeartbeatAckChunk
+{
+    uint8_t info[0];
+} SctpHeartbeatAckChunk;
+
+typedef struct _SctpAbortChunk
+{
+    uint8_t causes[0];
+} SctpAbortChunk;
+
+typedef struct _SctpShutdownChunk
+{
+    uint32_t tsn_ack;
+} SctpShutdownChunk;
+
+typedef struct _SctpErrorChunk
+{
+    uint8_t causes[0];
+} SctpErrorChunk;
+
+typedef struct _SctpCookieEchoChunk
+{
+    char *cookie;
+} SctpCookieEchoChunk;
+
+typedef struct _SctpEcneChunk
+{
+    uint32_t lowest_tsn;
+} SctpEcneChunk;
+
+typedef struct _SctpCwrChunk
+{
+    uint32_t lowest_tsn;
+} SctpCwrChunk;
+
+typedef struct _SctpAuthChunk
+{
+    uint16_t skey_id;
+    uint16_t hmac_id;
+    uint8_t hmac[0];
+    uint8_t params[0];
+} SctpAuthChunk;
+
+typedef struct _SctpAsconfAckChunk
+{
+    uint32_t seq;
+    uint8_t params[0];
+} SctpAsconfAckChunk;
+
+typedef struct _SctpPktdropChunk
+{
+    uint32_t lbmr;
+    uint32_t queue_size;
+    uint16_t trunc_length;
+    uint16_t reserved;
+    uint8_t dropped_pkt[0];
+} SctpPktdropChunk;
+
+typedef struct _SctpReConfigChunk
+{
+    uint8_t params[0];
+} SctpReConfigChunk;
+
+typedef struct _SctpPadChunk
+{
+    uint8_t padding[0];
+} SctpPadChunk;
+
+typedef struct _SctpForwardTsnChunk
+{
+    uint32_t new_tsn;
+    uint8_t streams[0];
+} SctpForwardTsnChunk;
+
+typedef struct _SctpAsconfChunk
+{
+    uint32_t seq;
+    /* One IPv4 or IPv6 addr param is mandatory, but start at params[0]. */
+    uint8_t params[0];
+} SctpAsconfChunk;
+
+
+/* Sctp Chunk structure. */
+typedef struct _SctpChunk
+{
+    uint8_t type;      /* chunk type */
+    uint8_t flags;     /* chunk flags */
+    uint16_t length;   /* chunk length */
+
+    union
+    {
+        SctpDataChunk data;
+        SctpInitChunk init;
+        SctpInitAckChunk init_ack;
+        SctpSackChunk sack;
+        SctpHeartbeatChunk heartbeat;
+        SctpHeartbeatAckChunk heartbeat_ack;
+        SctpAbortChunk abort;
+        SctpShutdownChunk shutdown;
+        /* No struct for shutdown_ack. */
+        SctpErrorChunk error;
+        SctpCookieEchoChunk cookie_echo;
+        /* No struct for cookie_ack. */
+        SctpEcneChunk ecne;
+        SctpEcneChunk cwr;
+        /* No struct for shutdown_complete. */
+        SctpAuthChunk auth;
+        SctpAsconfAckChunk asconf_ack;
+        SctpPktdropChunk pktdrop;
+        SctpReConfigChunk reconfig;
+        SctpPadChunk pad;
+        SctpForwardTsnChunk forward_tsn;
+        SctpAsconfChunk asconf;
+    };
+} SctpChunk;
+
+#pragma pack(pop)   /* restore original alignment from stack */
+
+
+#ifdef _MSC_VER
+  /* Visual C++ pragma to enable warning messages
+   * about nonstandard bit field type
+   */
+  #pragma warning( default : 4214 )
+#endif
+/* End SCTP data structures */
+
+
+/*
+ * SCTP prototypes for utility functions used in other modules.
+ */
+
+inline uint32_t SctpGetNextChunk(SctpChunk *c, uint32_t rlen, uint16_t clen);
+inline uint16_t SctpGetNextCause(SctpCause *c, uint16_t rclen, uint16_t clen);
+inline uint16_t SctpGetNextParam(SctpParam *p, uint16_t rclen, uint16_t plen);
+
+/* End SCTP prottypes */
+
+
 #ifndef NO_NON_ETHER_DECODER
 typedef struct _EtherEapol
 {
@@ -1678,6 +2001,7 @@ typedef struct _Packet
     const UDPHdr *udph, *orig_udph;
     const UDPHdr *inner_udph;   /* if Teredo + UDP, this will be the inner UDP header */
     const UDPHdr *outer_udph;   /* if Teredo + UDP, this will be the outer UDP header */
+    const SCTPHdr *sctph, *orig_sctph;
     const ICMPHdr *icmph, *orig_icmph;
 
     const uint8_t *data;        /* packet payload pointer */
@@ -1722,6 +2046,7 @@ typedef struct _Packet
     uint32_t preprocessor_bits; /* flags for preprocessors to check */
     uint32_t preproc_reassembly_pkt_bits;
 
+    uint32_t sctp_chunk_count;  /* Counter for # of SCTP chunks in an SCTP packet. */
     uint32_t http_pipeline_count; /* Counter for HTTP pipelined requests */
     uint32_t packet_flags;      /* special flags for the packet */
 
@@ -1744,10 +2069,10 @@ typedef struct _Packet
     uint16_t tcp_options_len;
 
     //vvv-----------------------------
-    uint16_t sp;                /* source port (TCP/UDP) */
-    uint16_t dp;                /* dest port (TCP/UDP) */
-    uint16_t orig_sp;           /* source port (TCP/UDP) of original datagram */
-    uint16_t orig_dp;           /* dest port (TCP/UDP) of original datagram */
+    uint16_t sp;                /* source port (TCP/UDP/SCTP) */
+    uint16_t dp;                /* dest port (TCP/UDP/SCTP) */
+    uint16_t orig_sp;           /* source port (TCP/UDP/SCTP) of original datagram */
+    uint16_t orig_dp;           /* dest port (TCP/UDP/SCTP) of original datagram */
     //^^^-----------------------------
     // and so on ...
 
@@ -1831,14 +2156,16 @@ typedef struct _Packet
 #define PROTO_BIT__ARP      0x0002
 #define PROTO_BIT__TCP      0x0004
 #define PROTO_BIT__UDP      0x0008
-#define PROTO_BIT__ICMP     0x0010
-#define PROTO_BIT__TEREDO   0x0020
-#define PROTO_BIT__GTP      0x0040
+#define PROTO_BIT__SCTP     0x0010
+#define PROTO_BIT__ICMP     0x0020
+#define PROTO_BIT__TEREDO   0x0040
+#define PROTO_BIT__GTP      0x0080
 #define PROTO_BIT__ALL      0xffff
 
 #define IsIP(p) (IPH_IS_VALID(p))
 #define IsTCP(p) (IsIP(p) && (GET_IPH_PROTO(p) == IPPROTO_TCP))
 #define IsUDP(p) (IsIP(p) && (GET_IPH_PROTO(p) == IPPROTO_UDP))
+#define IsSCTP(p) (IsIP(p) && (GET_IPH_PROTO(p) == IPPROTO_SCTP))
 #define IsICMP(p) (IsIP(p) && (GET_IPH_PROTO(p) == IPPROTO_ICMP))
 #define GET_PKT_SEQ(p) (ntohl(p->tcph->th_seq))
 
@@ -1948,6 +2275,7 @@ void DecodeIP(const uint8_t *, const uint32_t, Packet *);
 void DecodeIPV6(const uint8_t *, uint32_t, Packet *);
 void DecodeTCP(const uint8_t *, const uint32_t, Packet *);
 void DecodeUDP(const uint8_t *, const uint32_t, Packet *);
+void DecodeSCTP(const uint8_t *, const uint32_t, Packet *);
 void DecodeICMP(const uint8_t *, const uint32_t, Packet *);
 void DecodeICMP6(const uint8_t *, const uint32_t, Packet *);
 void DecodeICMPEmbeddedIP(const uint8_t *, const uint32_t, Packet *);
diff --git a/src/detection-plugins/Makefile.am b/src/detection-plugins/Makefile.am
index 94a3c80..f8cc24f 100644
--- a/src/detection-plugins/Makefile.am
+++ b/src/detection-plugins/Makefile.am
@@ -61,7 +61,12 @@ sp_urilen_check.c sp_urilen_check.h \
 sp_file_data.c sp_file_data.h \
 sp_base64_decode.c sp_base64_decode.h \
 sp_base64_data.c sp_base64_data.h \
-sp_pkt_data.c sp_pkt_data.h
+sp_pkt_data.c sp_pkt_data.h \
+sp_sctp_chunk_type.c sp_sctp_chunk_type.h \
+sp_sctp_chunk_flags.c sp_sctp_chunk_flags.h \
+sp_sctp_chunk_field.c sp_sctp_chunk_field.h \
+sp_sctp_num_chunks.c sp_sctp_num_chunks.h \
+sp_sctp_cause_code.c sp_sctp_cause_code.h
 
 copy_files = \
 	if test -f $$dst_file; then \
diff --git a/src/detection-plugins/detection_options.c b/src/detection-plugins/detection_options.c
index d683f2c..f99ed63 100644
--- a/src/detection-plugins/detection_options.c
+++ b/src/detection-plugins/detection_options.c
@@ -69,6 +69,11 @@
 #include "sp_isdataat.h"
 #include "sp_pattern_match.h"
 #include "sp_pcre.h"
+#include "sp_sctp_chunk_type.h"
+#include "sp_sctp_chunk_flags.h"
+#include "sp_sctp_chunk_field.h"
+#include "sp_sctp_num_chunks.h"
+#include "sp_sctp_cause_code.h"
 #ifdef ENABLE_REACT
 #include "sp_react.h"
 #endif
@@ -225,6 +230,21 @@ uint32_t detection_option_hash_func(SFHASHFCN *p, unsigned char *k, int n)
         case RULE_OPTION_TYPE_URILEN:
             hash = UriLenCheckHash(key->option_data);
             break;
+        case RULE_OPTION_TYPE_SCTP_CHUNK_TYPE:
+            hash = SctpChunkTypeHash(key->option_data);
+            break;
+        case RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS:
+            hash = SctpChunkFlagsHash(key->option_data);
+            break;
+        case RULE_OPTION_TYPE_SCTP_CHUNK_FIELD:
+            hash = SctpChunkFieldHash(key->option_data);
+            break;
+        case RULE_OPTION_TYPE_SCTP_NUM_CHUNKS:
+            hash = SctpNumChunksHash(key->option_data);
+            break;
+        case RULE_OPTION_TYPE_SCTP_CAUSE_CODE:
+            hash = SctpCauseCodeHash(key->option_data);
+            break;
 #ifdef DYNAMIC_PLUGIN
         case RULE_OPTION_TYPE_HDR_OPT_CHECK:
             hash = HdrOptCheckHash(key->option_data);
@@ -379,6 +399,21 @@ int detection_option_key_compare_func(const void *k1, const void *k2, size_t n)
         case RULE_OPTION_TYPE_URILEN:
             ret = UriLenCheckCompare(key1->option_data, key2->option_data);
             break;
+        case RULE_OPTION_TYPE_SCTP_CHUNK_TYPE:
+            ret = SctpChunkTypeCompare(key1->option_data, key2->option_data);
+            break;
+        case RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS:
+            ret = SctpChunkFlagsCompare(key1->option_data, key2->option_data);
+            break;
+        case RULE_OPTION_TYPE_SCTP_CHUNK_FIELD:
+            ret = SctpChunkFieldCompare(key1->option_data, key2->option_data);
+            break;
+        case RULE_OPTION_TYPE_SCTP_NUM_CHUNKS:
+            ret = SctpNumChunksCompare(key1->option_data, key2->option_data);
+            break;
+        case RULE_OPTION_TYPE_SCTP_CAUSE_CODE:
+            ret = SctpCauseCodeCompare(key1->option_data, key2->option_data);
+            break;
 #ifdef DYNAMIC_PLUGIN
         case RULE_OPTION_TYPE_HDR_OPT_CHECK:
             ret = HdrOptCheckCompare(key1->option_data, key2->option_data);
@@ -402,130 +437,86 @@ int detection_hash_free_func(void *option_key, void *data)
     switch (key->option_type)
     {
         /* Call free function specific to the key type */
-        case RULE_OPTION_TYPE_ASN1:
-            free(key->option_data);
+        case RULE_OPTION_TYPE_CONTENT:
+        case RULE_OPTION_TYPE_CONTENT_URI:
+            PatternMatchFree(key->option_data);
             break;
+
+        case RULE_OPTION_TYPE_ASN1:
         case RULE_OPTION_TYPE_BYTE_TEST:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_BYTE_JUMP:
-            free(key->option_data);
-            break;
-        case RULE_OPTION_TYPE_BYTE_EXTRACT:
-            ByteExtractFree(key->option_data);
-            break;
         case RULE_OPTION_TYPE_FLOW:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_CVS:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_DSIZE:
-            free(key->option_data);
-            break;
-        case RULE_OPTION_TYPE_FLOWBIT:
-            FlowBitsFree(key->option_data);
-            break;
-        case RULE_OPTION_TYPE_FTPBOUNCE:
-            /* Data is NULL, nothing to free */
-            break;
         case RULE_OPTION_TYPE_FILE_DATA:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_BASE64_DECODE:
-            free(key->option_data);
-            break;
-        case RULE_OPTION_TYPE_BASE64_DATA:
-            break;
-        case RULE_OPTION_TYPE_PKT_DATA:
-            break;
         case RULE_OPTION_TYPE_ICMP_CODE:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_ICMP_ID:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_ICMP_SEQ:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_ICMP_TYPE:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_IP_FRAGBITS:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_IP_FRAG_OFFSET:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_IP_ID:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_IP_OPTION:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_IP_PROTO:
-            free(key->option_data);
-            break;
-        case RULE_OPTION_TYPE_IP_SAME:
-            /* Data is NULL, nothing to free */
-            break;
         case RULE_OPTION_TYPE_IP_TOS:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_IS_DATA_AT:
-            free(key->option_data);
-            break;
-        case RULE_OPTION_TYPE_CONTENT:
-        case RULE_OPTION_TYPE_CONTENT_URI:
-            PatternMatchFree(key->option_data);
-            break;
-        case RULE_OPTION_TYPE_PCRE:
-            PcreFree(key->option_data);
-            break;
-#ifdef ENABLE_REACT
-        case RULE_OPTION_TYPE_REACT:
-            ReactFree(key->option_data);
-            break;
-#endif
 #ifdef ENABLE_RESPOND
         case RULE_OPTION_TYPE_RESPOND:
-            free(key->option_data);
-            break;
 #endif
         case RULE_OPTION_TYPE_RPC_CHECK:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_SESSION:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_TCP_ACK:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_TCP_FLAG:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_TCP_SEQ:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_TCP_WIN:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_TTL:
-            free(key->option_data);
-            break;
         case RULE_OPTION_TYPE_URILEN:
+        case RULE_OPTION_TYPE_SCTP_CHUNK_TYPE:
+        case RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS:
+        case RULE_OPTION_TYPE_SCTP_CHUNK_FIELD:
+        case RULE_OPTION_TYPE_SCTP_NUM_CHUNKS:
+        case RULE_OPTION_TYPE_SCTP_CAUSE_CODE:
             free(key->option_data);
             break;
+
+        case RULE_OPTION_TYPE_FTPBOUNCE:
+        case RULE_OPTION_TYPE_BASE64_DATA:
+        case RULE_OPTION_TYPE_PKT_DATA:
+        case RULE_OPTION_TYPE_IP_SAME:
+            break;
+
+        case RULE_OPTION_TYPE_BYTE_EXTRACT:
+            ByteExtractFree(key->option_data);
+            break;
+
+        case RULE_OPTION_TYPE_FLOWBIT:
+            FlowBitsFree(key->option_data);
+            break;
+
+        case RULE_OPTION_TYPE_PCRE:
+            PcreFree(key->option_data);
+            break;
+
+#ifdef ENABLE_REACT
+        case RULE_OPTION_TYPE_REACT:
+            ReactFree(key->option_data);
+            break;
+#endif
+
 #ifdef DYNAMIC_PLUGIN
         case RULE_OPTION_TYPE_HDR_OPT_CHECK:
             break;
+
         case RULE_OPTION_TYPE_PREPROCESSOR:
             PreprocessorRuleOptionsFreeFunc(key->option_data);
             break;
+
         case RULE_OPTION_TYPE_DYNAMIC:
             fpDynamicDataFree(key->option_data);
             break;
 #endif
+
         case RULE_OPTION_TYPE_LEAF_NODE:
             break;
     }
@@ -771,12 +762,16 @@ char *option_type_str[] =
     "RULE_OPTION_TYPE_TCP_SEQ",
     "RULE_OPTION_TYPE_TCP_WIN",
     "RULE_OPTION_TYPE_TTL",
-    "RULE_OPTION_TYPE_URILEN"
+    "RULE_OPTION_TYPE_URILEN",
+    "RULE_OPTION_TYPE_SCTP_CHUNK_TYPE",
+    "RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS",
+    "RULE_OPTION_TYPE_SCTP_CHUNK_FIELD",
+    "RULE_OPTION_TYPE_SCTP_NUM_CHUNKS",
+    "RULE_OPTION_TYPE_SCTP_CAUSE_CODE",
 #ifdef DYNAMIC_PLUGIN
-    ,
     "RULE_OPTION_TYPE_HDR_OPT_CHECK",
     "RULE_OPTION_TYPE_PREPROCESSOR",
-    "RULE_OPTION_TYPE_DYNAMIC"
+    "RULE_OPTION_TYPE_DYNAMIC",
 #endif
 };
 
@@ -1144,6 +1139,11 @@ int detection_option_node_evaluate(detection_option_tree_node_t *node, detection
             case RULE_OPTION_TYPE_TCP_WIN:
             case RULE_OPTION_TYPE_TTL:
             case RULE_OPTION_TYPE_URILEN:
+            case RULE_OPTION_TYPE_SCTP_CHUNK_TYPE:
+            case RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS:
+            case RULE_OPTION_TYPE_SCTP_CHUNK_FIELD:
+            case RULE_OPTION_TYPE_SCTP_NUM_CHUNKS:
+            case RULE_OPTION_TYPE_SCTP_CAUSE_CODE:
 #ifdef DYNAMIC_PLUGIN
             case RULE_OPTION_TYPE_HDR_OPT_CHECK:
             case RULE_OPTION_TYPE_PREPROCESSOR:
